package de.hs_rm.cs.swt.knauf.unittestmittimer.timer;

import java.awt.event.ActionListener;

/**Durch Implementierung dieses Interfaces wird eine Timerimplementierung
 * gekapselt: entweder ein @see {@link javax.swing.Timer} (lst automatisch nach x Millisekunden
 * aus) oder ein Manueller Timer (simuliert ein Timer-Tick-Event, indem eine public
 * Methode des Timers aufgerufen werden muss).
 * 
 * Der Timer-Implementierung muss ein @see {@link ActionListener}
 * bergeben werden, der beim Auslsen des Timers aufgerufen wird.
 * Dieser ActionListener fhrt die Aktionen aus, die beim Timer-Auslsen erfolgen sollen
 * (Manipulation der Spiellogik)
 * 
 * Je nach Implementierung muss danach der Timer ber "start" gestartet werden.
 * 
 * @author Wolfgang Knauf
 *
 */
public interface ITimer
{
  /**Die Methode "actionPerformed" dieses ActionListener wird ausgelst,
   * wenn das Timer-Intervall abgelaufen ist.
   * Muss vor dem Aufruf von "start" gemacht werden.
   * 
   * @param actionListener Seine "actionPerformed"-Methode wird aufgerufen. NULL ist verboten
   */
  void addTimerListener ( ActionListener actionListener);
  
  /**Starten des Timers: ab diesem Zeitpunkt wird die Methode "actionPerformed"
   * des ber "addTimerListener" gesetzten ActionListener ausgelst.
   * 
   * 
   */
  void start();
}
